/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner{}

// AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner struct for AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner
type AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner struct {
	Id   *string `json:"_id,omitempty"`
	Name *string `json:"name,omitempty"`
}

// NewAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner instantiates a new AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner() *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner {
	this := AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner{}
	return &this
}

// NewAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInnerWithDefaults instantiates a new AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInnerWithDefaults() *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner {
	this := AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner) SetId(v string) {
	o.Id = &v
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner) GetName() string {
	if o == nil || IsNil(o.Name) {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner) GetNameOk() (*string, bool) {
	if o == nil || IsNil(o.Name) {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner) HasName() bool {
	if o != nil && !IsNil(o.Name) {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner) SetName(v string) {
	o.Name = &v
}

func (o AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["_id"] = o.Id
	}
	if !IsNil(o.Name) {
		toSerialize["name"] = o.Name
	}
	return toSerialize, nil
}

type NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner struct {
	value *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner
	isSet bool
}

func (v NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner) Get() *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner {
	return v.value
}

func (v *NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner) Set(val *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner) {
	v.value = val
	v.isSet = true
}

func (v NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner) IsSet() bool {
	return v.isSet
}

func (v *NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner(val *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner) *NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner {
	return &NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner{value: val, isSet: true}
}

func (v NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionProject200ResponseInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
